version: 2

sources:
  - name: gitlab_dotcom
    tags: ["tdf", "gitlab_dotcom"]
    database: '{{ env_var("SNOWFLAKE_LOAD_DATABASE") }}'
    schema: tap_postgres
    loaded_at_field: DATEADD(sec, _uploaded_at, '1970-01-01')
    loader: Airflow, tap_postgres
    description: Analytics read replica for Gitlab.com data. [Original Issue](https://gitlab.com/gitlab-com/gl-infra/infrastructure/issues/5847)

    quoting:
      database: true
      schema: false
      identifier: false

    freshness:
      warn_after: {count: 24, period: hour}
      error_after: {count: 48, period: hour}

    tables:
      - name: alert_management_alert_assignees
        identifier: gitlab_db_alert_management_alert_assignees
      - name: alert_management_alerts
        identifier: gitlab_db_alert_management_alerts
      - name: application_settings
        identifier: gitlab_db_application_settings
        freshness:
          warn_after: { count: 7, period: day }
          error_after: { count: 30, period: day }
      - name: approval_merge_request_rules
        identifier: gitlab_db_approval_merge_request_rules
      - name: approvals
        identifier: gitlab_db_approvals
      - name: audit_events
        identifier: gitlab_db_audit_events
        freshness:
          warn_after: {count: 7, period: day}
          error_after: {count: 30, period: day}
      - name: audit_events_external_audit_event_destinations
        identifier: gitlab_db_audit_events_external_audit_event_destinations
        freshness:
          warn_after: {count: 7, period: day}
          error_after: {count: 30, period: day}
      - name: award_emoji
        identifier: gitlab_db_award_emoji
      - name: banned_users
        identifier: gitlab_db_banned_users
        freshness: null
      - name: board_assignees
        identifier: gitlab_db_board_assignees
      - name: board_labels
        identifier: gitlab_db_board_labels
      - name: boards
        identifier: gitlab_db_boards
      - name: ci_build_trace_chunks
        identifier: gitlab_db_ci_build_trace_chunks
      - name: ci_build_trace_section_names
        identifier: gitlab_db_ci_build_trace_section_names
        description: This table pipeline is deprecated and won't be refreshed, Ref MR https://gitlab.com/gitlab-data/analytics/-/merge_requests/5334.
        freshness: null
      - name: ci_builds
        identifier: gitlab_db_ci_builds
      - name: ci_builds_runner_session
        identifier: gitlab_db_ci_builds_runner_session
      - name: ci_group_variables
        identifier: gitlab_db_ci_group_variables
      - name: ci_job_artifacts
        identifier: gitlab_db_ci_job_artifacts
      - name: ci_namespace_monthly_usages
        identifier: gitlab_db_ci_namespace_monthly_usages
      - name: ci_pipeline_chat_data
        identifier: gitlab_db_ci_pipeline_chat_data
      - name: ci_pipeline_schedule_variables
        identifier: gitlab_db_ci_pipeline_schedule_variables
      - name: ci_pipeline_schedules
        identifier: gitlab_db_ci_pipeline_schedules
      - name: ci_pipelines
        identifier: gitlab_db_ci_pipelines
      - name: ci_platform_metrics
        identifier: gitlab_db_ci_platform_metrics
      - name: ci_project_monthly_usages
        identifier: gitlab_db_ci_project_monthly_usages
      - name: ci_runner_projects
        identifier: gitlab_db_ci_runner_projects
      - name: ci_runners
        identifier: gitlab_db_ci_runners
      - name: ci_sources_pipelines
        identifier: gitlab_db_ci_sources_pipelines
      - name: ci_stages
        identifier: gitlab_db_ci_stages
      - name: ci_trigger_requests
        identifier: gitlab_db_ci_trigger_requests
      - name: ci_triggers
        identifier: gitlab_db_ci_triggers
      - name: ci_variables
        identifier: gitlab_db_ci_variables
      - name: cluster_groups
        identifier: gitlab_db_cluster_groups
      - name: clusters_integration_elasticstack
        identifier: gitlab_db_clusters_integration_elasticstack
        freshness: null
      - name: clusters_integration_prometheus
        identifier: gitlab_db_clusters_integration_prometheus
      - name: cluster_projects
        identifier: gitlab_db_cluster_projects
      - name: clusters
        identifier: gitlab_db_clusters
      - name: clusters_applications_cert_managers
        identifier: gitlab_db_clusters_applications_cert_managers
        freshness: null
      - name: clusters_applications_crossplane
        identifier: gitlab_db_clusters_applications_crossplane
        freshness: null
      - name: clusters_applications_elastic_stacks
        identifier: gitlab_db_clusters_applications_elastic_stacks
        freshness: null
      - name: clusters_applications_helm
        identifier: gitlab_db_clusters_applications_helm
        freshness: null
      - name: clusters_applications_ingress
        identifier: gitlab_db_clusters_applications_ingress
        freshness: null
      - name: clusters_applications_jupyter
        identifier: gitlab_db_clusters_applications_jupyter
        freshness: null
      - name: clusters_applications_knative
        identifier: gitlab_db_clusters_applications_knative
        freshness: null
      - name: clusters_applications_prometheus
        identifier: gitlab_db_clusters_applications_prometheus
        freshness: null
      - name: clusters_applications_runners
        identifier: gitlab_db_clusters_applications_runners
        freshness: null
      - name: dast_profiles
        identifier: gitlab_db_dast_profiles
        freshness:
          warn_after: {count: 7, period: day}
          error_after: {count: 15, period: day}
      - name: deployments
        identifier: gitlab_db_deployments
      - name: deployment_merge_requests
        identifier: gitlab_db_deployment_merge_requests
      - name: design_management_designs_versions
        identifier: gitlab_db_design_management_designs_versions
      - name: design_management_designs
        identifier: gitlab_db_design_management_designs
      - name: design_management_versions
        identifier: gitlab_db_design_management_versions
        freshness: null
      - name: elasticsearch_indexed_namespaces
        identifier: gitlab_db_elasticsearch_indexed_namespaces
        freshness:
          warn_after: {count: 7, period: day}
          error_after: {count: 30, period: day}
      - name: emails
        identifier: gitlab_db_emails
      - name: environments
        identifier: gitlab_db_environments
      - name: epic_issues
        identifier: gitlab_db_epic_issues
      - name: epics
        identifier: gitlab_db_epics
      - name: events
        identifier: gitlab_db_events
      - name: experiment_subjects
        identifier: gitlab_db_experiment_subjects
      - name: experiment_users
        identifier: gitlab_db_experiment_users
        freshness: null #https://gitlab.com/gitlab-data/analytics/-/merge_requests/5998
      - name: experiments
        identifier: gitlab_db_experiments
      - name: external_status_checks
        identifier: gitlab_db_external_status_checks
        freshness:
          warn_after: {count: 7, period: day}
          error_after: {count: 15, period: day}
      - name: gitlab_subscription_histories
        identifier: gitlab_db_gitlab_subscription_histories
      - name: gitlab_subscriptions
        identifier: gitlab_db_gitlab_subscriptions
      - name: group_group_links
        identifier: gitlab_db_group_group_links
      - name: identities
        identifier: gitlab_db_identities
      - name: in_product_marketing_emails
        identifier: gitlab_db_in_product_marketing_emails
      - name: issuable_severities
        identifier: gitlab_db_issuable_severities
      - name: issue_assignees
        identifier: gitlab_db_issue_assignees
      - name: issue_links
        identifier: gitlab_db_issue_links
      - name: issue_metrics
        identifier: gitlab_db_issue_metrics
      - name: issues
        identifier: gitlab_db_issues
      - name: keys
        identifier: gitlab_db_keys
      - name: label_links
        identifier: gitlab_db_label_links
      - name: label_priorities
        identifier: gitlab_db_label_priorities
      - name: labels
        identifier: gitlab_db_labels
      - name: lfs_objects_projects
        identifier: gitlab_db_lfs_objects_projects
      - name: lists
        identifier: gitlab_db_lists
      - name: members
        identifier: gitlab_db_members
      - name: merge_request_blocks
        identifier: gitlab_db_merge_request_blocks
      - name: merge_request_diffs
        identifier: gitlab_db_merge_request_diffs
      - name: merge_request_metrics
        identifier: gitlab_db_merge_request_metrics
      - name: merge_requests
        identifier: gitlab_db_merge_requests
      - name: merge_requests_closing_issues
        identifier: gitlab_db_merge_requests_closing_issues
      - name: merge_request_reviewers
        identifier: gitlab_db_merge_request_reviewers
      - name: milestone_releases
        identifier: gitlab_db_milestone_releases
      - name: milestones
        identifier: gitlab_db_milestones
      - name: namespace_root_storage_statistics
        identifier: gitlab_db_namespace_root_storage_statistics
      - name: namespace_settings
        identifier:  gitlab_db_namespace_settings
      - name: namespace_statistics
        identifier: gitlab_db_namespace_statistics
      - name: namespaces
        identifier: gitlab_db_namespaces
      - name: notes
        identifier: gitlab_db_notes
      - name: notification_settings
        identifier: gitlab_db_notification_settings
      - name: oauth_access_tokens
        identifier: gitlab_db_oauth_access_tokens
      - name: onboarding_progresses
        identifier: gitlab_db_onboarding_progresses
      - name: packages_packages
        identifier: gitlab_db_packages_packages
      - name: plans
        identifier: gitlab_db_plans
      - name: pages_domains
        identifier: gitlab_db_pages_domains
      - name: programming_languages
        identifier: gitlab_db_programming_languages
      - name: project_auto_devops
        identifier: gitlab_db_project_auto_devops
      - name: project_custom_attributes
        identifier: gitlab_db_project_custom_attributes
        freshness: null
      - name: project_features
        identifier: gitlab_db_project_features
        freshness:
          warn_after: { count: 2, period: day }
          error_after: { count: 4, period: day }
      - name: project_group_links
        identifier: gitlab_db_project_group_links
      - name: project_import_data
        identifier: gitlab_db_project_import_data
      - name: project_mirror_data
        identifier: gitlab_db_project_mirror_data
      - name: project_repositories
        identifier: gitlab_db_project_repositories
      - name: project_repository_storage_moves
        identifier: gitlab_db_project_repository_storage_moves
      - name: project_settings
        identifier: gitlab_db_project_settings
      - name: project_statistics
        identifier: gitlab_db_project_statistics
      - name: projects
        identifier: gitlab_db_projects
      - name: prometheus_alerts
        identifier: gitlab_db_prometheus_alerts
        freshness: null #https://gitlab.com/gitlab-data/analytics/-/issues/10835
      - name: protected_branches
        identifier: gitlab_db_protected_branches
      - name: push_rules
        identifier: gitlab_db_push_rules
      - name: releases
        identifier: gitlab_db_releases
      - name: repository_languages
        identifier: gitlab_db_repository_languages
      - name: requirements
        identifier: gitlab_db_requirements
      - name: resource_label_events
        identifier: gitlab_db_resource_label_events
      - name: resource_milestone_events
        identifier: gitlab_db_resource_milestone_events
      - name: resource_weight_events
        identifier: gitlab_db_resource_weight_events
      - name: routes
        identifier: gitlab_db_routes
      - name: saml_providers
        identifier: gitlab_db_saml_providers
      - name: services
        identifier: gitlab_db_services
      - name: shards
        identifier: gitlab_db_shards
      - name: sprints
        identifier: gitlab_db_sprints
      - name: subscriptions
        identifier: gitlab_db_subscriptions
      - name: system_note_metadata
        identifier: gitlab_db_system_note_metadata
      - name: snippets
        identifier: gitlab_db_snippets
      - name: terraform_states
        identifier: gitlab_db_terraform_states
      - name: timelogs
        identifier: gitlab_db_timelogs
      - name: todos
        identifier: gitlab_db_todos
      - name: user_details
        identifier: gitlab_db_user_details
      - name: user_preferences
        identifier: gitlab_db_user_preferences
      - name: users
        identifier: gitlab_db_users
      - name: user_custom_attributes
        identifier: gitlab_db_user_custom_attributes
        freshness:
          warn_after: { count: 7, period: day }
          error_after: { count: 30, period: day }
      - name: users_security_dashboard_projects
        identifier: gitlab_db_users_security_dashboard_projects
      - name: vulnerabilities
        identifier: gitlab_db_vulnerabilities
      - name: vulnerability_occurrences
        identifier: gitlab_db_vulnerability_occurrences
      - name: alert_management_http_integrations
        identifier: gitlab_db_alert_management_http_integrations
        freshness: null
      - name: analytics_cycle_analytics_group_stages
        identifier: gitlab_db_analytics_cycle_analytics_group_stages
        freshness:
          warn_after: { count: 3, period: day }
          error_after: { count: 7, period: day }
      - name: approval_merge_request_rule_sources
        identifier: gitlab_db_approval_merge_request_rule_sources
      - name: approval_project_rules
        identifier: gitlab_db_approval_project_rules
      - name: approval_project_rules_groups
        identifier: gitlab_db_approval_project_rules_groups
      - name: approval_project_rules_protected_branches
        identifier: gitlab_db_approval_project_rules_protected_branches
      - name: approval_project_rules_users
        identifier: gitlab_db_approval_project_rules_users
      - name: authentication_events
        identifier: gitlab_db_authentication_events
      - name: bulk_imports
        identifier: gitlab_db_bulk_imports
        freshness:
          warn_after: { count: 14, period: day }
          error_after: { count: 30, period: day }
      - name: bulk_import_entities
        identifier: gitlab_db_bulk_import_entities
        freshness:
          warn_after: { count: 10, period: day }
          error_after: { count: 15, period: day }
      - name: cluster_agent_tokens
        identifier: gitlab_db_cluster_agent_tokens
        freshness:
          warn_after: { count: 3, period: day }
          error_after: { count: 7, period: day }
      - name: cluster_agents
        identifier: gitlab_db_cluster_agents
        freshness:
          warn_after: { count: 3, period: day }
          error_after: { count: 7, period: day }
      - name: container_expiration_policies
        identifier: gitlab_db_container_expiration_policies
      - name: compliance_management_frameworks
        identifier: gitlab_db_compliance_management_frameworks
      - name: csv_issue_imports
        identifier: gitlab_db_csv_issue_imports
      - name: gitlab_pgp_export
        identifier: gitlab_pgp_export
        loaded_at_field: DATEADD(sec, _updated_at, '1970-01-01')
      - name: grafana_integrations
        identifier: gitlab_db_grafana_integrations
        freshness:
          warn_after: {count: 7, period: day}
          error_after: {count: 14, period: day}
      - name: group_import_states
        identifier: gitlab_db_group_import_states
      - name: integrations
        identifier: gitlab_db_integrations
      - name: jira_imports
        identifier: gitlab_db_jira_imports
        freshness:
          warn_after: {count: 2, period: day}
          error_after: {count: 4, period: day}
      - name: jira_tracker_data
        identifier: gitlab_db_jira_tracker_data
      - name: ldap_group_links
        identifier: gitlab_db_ldap_group_links
        freshness: null
      - name: lfs_file_locks
        identifier: gitlab_db_lfs_file_locks
      - name: lfs_objects
        identifier: gitlab_db_lfs_objects
      - name: operations_feature_flags
        identifier: gitlab_db_operations_feature_flags
      - name: path_locks
        identifier: gitlab_db_path_locks
      - name: pool_repositories
        identifier: gitlab_db_pool_repositories
      - name: project_compliance_framework_settings
        identifier: gitlab_db_project_compliance_framework_settings
      - name: project_error_tracking_settings
        identifier: gitlab_db_project_error_tracking_settings
      - name: project_feature_usages
        identifier: gitlab_db_project_feature_usages
      - name: project_incident_management_settings
        identifier: gitlab_db_project_incident_management_settings
      - name: project_tracing_settings
        identifier: gitlab_db_project_tracing_settings
        freshness: null
      - name: remote_mirrors
        identifier: gitlab_db_remote_mirrors
      - name: security_scans
        identifier: gitlab_db_security_scans
      - name: sentry_issues
        identifier: gitlab_db_sentry_issues
      - name: status_page_published_incidents
        identifier: gitlab_db_status_page_published_incidents
        freshness: null
      - name: status_page_settings
        identifier: gitlab_db_status_page_settings
        freshness: null
      - name: suggestions
        identifier: gitlab_db_suggestions
      - name: uploads
        identifier: gitlab_db_uploads
      - name: users_ops_dashboard_projects
        identifier: gitlab_db_users_ops_dashboard_projects
      - name: web_hooks
        identifier: gitlab_db_web_hooks
      - name: zoom_meetings
        identifier: gitlab_db_zoom_meetings
        freshness:
          warn_after: { count: 7, period: day }
          error_after: { count: 30, period: day }
      - name: user_credit_card_validations
        identifier: gitlab_db_user_credit_card_validations
      - name: boards_epic_boards
        identifier: gitlab_db_boards_epic_boards
